diff -ruN vdr-1.7.20/CONTRIBUTORS vdr-1.7.21/CONTRIBUTORS
--- vdr-1.7.20/CONTRIBUTORS	2011-08-15 14:45:40.000000000 +0200
+++ vdr-1.7.21/CONTRIBUTORS	2011-08-27 16:27:22.000000000 +0200
@@ -743,6 +743,7 @@
  for helping to debug a crash when using the --terminal option without having access
  to the given terminal
  for fixing following symbolic links in RemoveFileOrDir()
+ for suggesting to cache the length of a recording's index
 
 Peter Seyringer <e9425234@student.tuwien.ac.at>
  for reporting a bug in saving the polarization parameter of channels that have a
@@ -1111,6 +1112,11 @@
  for fixing some crashes in subtitle display
  for reporting that DELETENULL() was not thread safe
  for reporting a crash in subtitle display, related to cOsd::Osds
+ for a patch that stores the subtitle PIDs in the channels.conf file
+ for suggesting to implement a way for devices to tell whether they can provide EIT data
+ for making the Audio and Subtitles options available through the Green and Yellow
+ keys in the Setup/DVB menu
+ for making the Recordings menu display the length (in hours:minutes) of each recording
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1708,6 +1714,9 @@
  the marks file has just been written"
  for suggesting a fix for a bug in handling DiSEqC codes
  for fixing handling the channelID in cMenuEditChanItem
+ for a patch that sets the start time of an edited recording to the time of the first
+ editing mark
+ for adding the option --outputonly to the dvbsddevice plugin
 
 Sven Kreiensen <svenk@kammer.uni-hannover.de>
  for his help in keeping 'channels.conf.terr' up to date
@@ -2593,6 +2602,8 @@
  for reporting a problem with the fps value in the info file of a recording being
  overwritten in case a recording was interrupted and resumed, and the fps value
  could not be determined after resuming recording
+ for reporting a problem with detecting frames for channels that split frames into
+ several payloads
 
 Marcel Unbehaun <frostworks@gmx.de>
  for adding cRecordingInfo::GetEvent()
@@ -2760,3 +2771,6 @@
 Frank Niederwipper <f.niederwipper@gmail.com>
  for reporting a problem in timer handling in case a recording directory can't
  be created
+
+Chris Mayo <aklhfex@gmail.com>
+ for reporting a problem with detecting frames on radio channels
diff -ruN vdr-1.7.20/HISTORY vdr-1.7.21/HISTORY
--- vdr-1.7.20/HISTORY	2011-08-15 15:44:16.000000000 +0200
+++ vdr-1.7.21/HISTORY	2011-09-04 15:07:04.000000000 +0200
@@ -6698,3 +6698,47 @@
 - cTimeMs is no longer initialized to the current time if the value given to the
   constructor is negative (avoids the "cTimeMs: using monotonic clock..." log message
   before VDR's starting log message).
+
+2011-09-04: Version 1.7.21
+
+- Fixed detecting frames for channels that split frames into several payloads
+  (reported by Derek Kelly).
+- Now initializing Setup.InitialChannel to an empty string to avoid problems in
+  case there is no setup.conf.
+- The start time of an edited recording is now set to the time of the first
+  editing mark (thanks to Udo Richter).
+  This obsoletes the CUTTIME patch.
+- Direct access to the members start, priority, lifetime, and deleted of cRecording
+  as well as to position and comment of cMark is now deprecated. Plugin authors
+  should switch to the new access functions for these members. For now the macro
+  __RECORDING_H_DEPRECATED_DIRECT_MEMBER_ACCESS is defined in recording.h, which
+  exposes these members, so that existing plugins will still compile. Comment out
+  this #define to check whether a particular plugin needs to be modified.
+  This #define may be removed in a future version.
+- The new functions cRecording::NumFrames() and cRecording::LengthInSeconds() return
+  the number of frames and length (in seconds) of a recording (suggested by Steffen
+  Barszus).
+- The subtitle PIDs are now stored in the channels.conf file as an extension to the
+  TPID field (thanks to Rolf Ahrenberg).
+- The new function cDevice::ProvidesEIT() is used to determine whether a device can
+  provide EIT data and will thus be used in cEITScanner::Process() to receive EIT
+  data from the channels it can receive (suggested by Rolf Ahrenberg). Note that by
+  default it is assumed that a device can't provide EIT data, and only the builtin
+  cDvbDevice returns true from this function.
+- The Audio and Subtitles options are now available through the Green and Yellow
+  keys in the Setup/DVB menu (thanks to Rolf Ahrenberg). This is mainly for remote
+  controls that don't have dedicated keys for these functions.
+- The SVDRP command HITK now accepts multiple keys (up to 31).
+- The Recordings menu now displays the length (in hours:minutes) of each recording
+  (thanks to Rolf Ahrenberg). Note that the "new" indicator has been moved from the
+  recording time to the length column. This new format is also used by the SVDRP
+  command LSTR, so in case you have an application that parses the LSTR output,
+  you will need to adjust it to the new format.
+- The dvbsddevice plugin now supports the new option --outputonly, which disables
+  receiving on SD FF devices and uses the device only for output (thanks to Udo
+  Richter).
+- Fixed detecting frames on radio channels (reported by Chris Mayo).
+- Revoked the changes to cFrameDetector that have been introduced in version 1.7.19.
+  Detecting frames in case the Picture Start Code or Access Unit Delimiter
+  extends over TS packet boundaries is now done by locally skipping TS packets
+  in cFrameDetector.
diff -ruN vdr-1.7.20/PLUGINS/src/dvbhddevice/dvbhddevice.c vdr-1.7.21/PLUGINS/src/dvbhddevice/dvbhddevice.c
--- vdr-1.7.20/PLUGINS/src/dvbhddevice/dvbhddevice.c	2011-04-24 11:31:21.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbhddevice/dvbhddevice.c	2011-08-27 11:31:45.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbhddevice.c 1.13 2011/04/24 09:31:21 kls Exp $
+ * $Id: dvbhddevice.c 1.14 2011/08/27 09:31:45 kls Exp $
  */
 
 #include <vdr/plugin.h>
@@ -11,7 +11,7 @@
 #include "setup.h"
 
 static const char *VERSION        = "0.0.4";
-static const char *DESCRIPTION    = "HD Full Featured DVB device";
+static const char *DESCRIPTION    = trNOOP("HD Full Featured DVB device");
 
 class cPluginDvbhddevice : public cPlugin {
 private:
@@ -20,7 +20,7 @@
   cPluginDvbhddevice(void);
   virtual ~cPluginDvbhddevice();
   virtual const char *Version(void) { return VERSION; }
-  virtual const char *Description(void) { return DESCRIPTION; }
+  virtual const char *Description(void) { return tr(DESCRIPTION); }
   virtual cMenuSetupPage *SetupMenu(void);
   virtual bool SetupParse(const char *Name, const char *Value);
   };
diff -ruN vdr-1.7.20/PLUGINS/src/dvbhddevice/dvbhdffdevice.c vdr-1.7.21/PLUGINS/src/dvbhddevice/dvbhdffdevice.c
--- vdr-1.7.20/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2011-05-22 17:19:59.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2011-08-27 11:32:18.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbhdffdevice.c 1.32 2011/05/22 15:19:59 kls Exp $
+ * $Id: dvbhdffdevice.c 1.33 2011/08/27 09:32:18 kls Exp $
  */
 
 #include "dvbhdffdevice.h"
@@ -54,6 +54,7 @@
      hdmiConfig.TransmitAudio = true;
      hdmiConfig.ForceDviMode = false;
      hdmiConfig.CecEnabled = gHdffSetup.CecEnabled;
+     hdmiConfig.VideoModeAdaption = (HDFF::eVideoModeAdaption) gHdffSetup.VideoModeAdaption;
      mHdffCmdIf->CmdHdmiConfigure(&hdmiConfig);
      if (gHdffSetup.CecEnabled)
         mHdffCmdIf->CmdHdmiSendCecCommand(HDFF::cecCommandTvOn);
@@ -110,7 +111,7 @@
 {
   HDFF::tVideoFormat videoFormat;
   videoFormat.AutomaticEnabled = true;
-  videoFormat.AfdEnabled = false;
+  videoFormat.AfdEnabled = true;
   videoFormat.TvFormat = (HDFF::eTvFormat) gHdffSetup.TvFormat;
   videoFormat.VideoConversion = (HDFF::eVideoConversion) gHdffSetup.VideoConversion;
   mHdffCmdIf->CmdAvSetVideoFormat(0, &videoFormat);
@@ -729,10 +730,25 @@
     0x13C2300A, // Technotrend S2-6400 HDFF production version
     0x00000000
     };
-  uint32_t SubsystemId = GetSubsystemId(Adapter, Frontend);
+  cString FileName;
+  cReadLine ReadLine;
+  FILE *f = NULL;
+  uint32_t SubsystemId = 0;
+  FileName = cString::sprintf("/sys/class/dvb/dvb%d.frontend%d/device/subsystem_vendor", Adapter, Frontend);
+  if ((f = fopen(FileName, "r")) != NULL) {
+     if (char *s = ReadLine.Read(f))
+        SubsystemId = strtoul(s, NULL, 0) << 16;
+     fclose(f);
+     }
+  FileName = cString::sprintf("/sys/class/dvb/dvb%d.frontend%d/device/subsystem_device", Adapter, Frontend);
+  if ((f = fopen(FileName, "r")) != NULL) {
+     if (char *s = ReadLine.Read(f))
+        SubsystemId |= strtoul(s, NULL, 0);
+     fclose(f);
+     }
   for (uint32_t *sid = SubsystemIds; *sid; sid++) {
       if (*sid == SubsystemId) {
-         cString FileName = cString::sprintf("/dev/dvb/adapter%d/osd0", Adapter);
+         FileName = cString::sprintf("/dev/dvb/adapter%d/osd0", Adapter);
          int fd = open(FileName, O_RDWR);
          if (fd != -1) { //TODO treat the second path of the S2-6400 as a budget device
             close(fd);
diff -ruN vdr-1.7.20/PLUGINS/src/dvbhddevice/hdffcmd.c vdr-1.7.21/PLUGINS/src/dvbhddevice/hdffcmd.c
--- vdr-1.7.20/PLUGINS/src/dvbhddevice/hdffcmd.c	2011-04-24 11:31:59.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbhddevice/hdffcmd.c	2011-08-27 11:34:18.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hdffcmd.c 1.20 2011/04/24 09:31:59 kls Exp $
+ * $Id: hdffcmd.c 1.21 2011/08/27 09:34:18 kls Exp $
  */
 
 #include "hdffcmd.h"
@@ -1089,6 +1089,7 @@
     {
         cmdBuf.SetBits(1, 0);
     }
+    cmdBuf.SetBits(3, (uint32_t) pConfig->VideoModeAdaption);
     osd_cmd.cmd_len = CmdSetLength(cmdBuf);
     ioctl(mOsdDev, OSD_RAW_CMD, &osd_cmd);
 }
diff -ruN vdr-1.7.20/PLUGINS/src/dvbhddevice/hdffmsgdef.h vdr-1.7.21/PLUGINS/src/dvbhddevice/hdffmsgdef.h
--- vdr-1.7.20/PLUGINS/src/dvbhddevice/hdffmsgdef.h	2011-04-17 13:20:22.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbhddevice/hdffmsgdef.h	2011-08-27 11:34:43.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hdffmsgdef.h 1.12 2011/04/17 11:20:22 kls Exp $
+ * $Id: hdffmsgdef.h 1.13 2011/08/27 09:34:43 kls Exp $
  */
 
 #ifndef _HDFF_MSGDEF_H_
@@ -274,6 +274,14 @@
     videoModeMaxValue
 } eHdmiVideoMode;
 
+typedef enum _eVideoModeAdaption
+{
+    videoModeAdaptOff,
+    videoModeAdaptFrameRate,
+    videoModeAdaptOnlyForHd,
+    videoModeAdaptAlways
+} eVideoModeAdaption;
+
 typedef enum _eCecCommand
 {
     cecCommandTvOn,
@@ -287,6 +295,7 @@
     bool TransmitAudio;
     bool ForceDviMode;
     bool CecEnabled;
+    eVideoModeAdaption VideoModeAdaption;
 } tHdmiConfig;
 
 // Remote control definitions
diff -ruN vdr-1.7.20/PLUGINS/src/dvbhddevice/setup.c vdr-1.7.21/PLUGINS/src/dvbhddevice/setup.c
--- vdr-1.7.20/PLUGINS/src/dvbhddevice/setup.c	2011-05-15 16:47:45.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbhddevice/setup.c	2011-08-27 11:35:35.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: setup.c 1.12 2011/05/15 14:47:45 kls Exp $
+ * $Id: setup.c 1.13 2011/08/27 09:35:35 kls Exp $
  */
 
 #include "setup.h"
@@ -20,6 +20,7 @@
 cHdffSetup::cHdffSetup(void)
 {
     Resolution = kResolution1080i;
+    VideoModeAdaption = HDFF::videoModeAdaptOff;
     TvFormat = HDFF::tvFormat16by9;
     VideoConversion = HDFF::videoConversionPillarbox;
     AnalogueVideo = HDFF::videoOutCvbsYuv;
@@ -35,18 +36,19 @@
 
 bool cHdffSetup::SetupParse(const char *Name, const char *Value)
 {
-    if      (strcmp(Name, "Resolution")      == 0) Resolution      = atoi(Value);
-    else if (strcmp(Name, "TvFormat")        == 0) TvFormat        = atoi(Value);
-    else if (strcmp(Name, "VideoConversion") == 0) VideoConversion = atoi(Value);
-    else if (strcmp(Name, "AnalogueVideo")   == 0) AnalogueVideo   = atoi(Value);
-    else if (strcmp(Name, "AudioDelay")      == 0) AudioDelay      = atoi(Value);
-    else if (strcmp(Name, "AudioDownmix")    == 0) AudioDownmix    = atoi(Value);
-    else if (strcmp(Name, "OsdSize")         == 0) OsdSize         = atoi(Value);
-    else if (strcmp(Name, "CecEnabled")      == 0) CecEnabled      = atoi(Value);
-    else if (strcmp(Name, "RemoteProtocol")  == 0) RemoteProtocol  = atoi(Value);
-    else if (strcmp(Name, "RemoteAddress")   == 0) RemoteAddress   = atoi(Value);
-    else if (strcmp(Name, "HighLevelOsd")    == 0) HighLevelOsd    = atoi(Value);
-    else if (strcmp(Name, "TrueColorOsd")    == 0) TrueColorOsd    = atoi(Value);
+    if      (strcmp(Name, "Resolution")        == 0) Resolution        = atoi(Value);
+    else if (strcmp(Name, "VideoModeAdaption") == 0) VideoModeAdaption = atoi(Value);
+    else if (strcmp(Name, "TvFormat")          == 0) TvFormat          = atoi(Value);
+    else if (strcmp(Name, "VideoConversion")   == 0) VideoConversion   = atoi(Value);
+    else if (strcmp(Name, "AnalogueVideo")     == 0) AnalogueVideo     = atoi(Value);
+    else if (strcmp(Name, "AudioDelay")        == 0) AudioDelay        = atoi(Value);
+    else if (strcmp(Name, "AudioDownmix")      == 0) AudioDownmix      = atoi(Value);
+    else if (strcmp(Name, "OsdSize")           == 0) OsdSize           = atoi(Value);
+    else if (strcmp(Name, "CecEnabled")        == 0) CecEnabled        = atoi(Value);
+    else if (strcmp(Name, "RemoteProtocol")    == 0) RemoteProtocol    = atoi(Value);
+    else if (strcmp(Name, "RemoteAddress")     == 0) RemoteAddress     = atoi(Value);
+    else if (strcmp(Name, "HighLevelOsd")      == 0) HighLevelOsd      = atoi(Value);
+    else if (strcmp(Name, "TrueColorOsd")      == 0) TrueColorOsd      = atoi(Value);
     else return false;
     return true;
 }
@@ -113,6 +115,7 @@
 cHdffSetupPage::cHdffSetupPage(HDFF::cHdffCmdIf * pHdffCmdIf)
 {
     const int kResolutions = 4;
+    const int kVideoModeAdaptions = 4;
     const int kTvFormats = 2;
     const int kVideoConversions = 6;
     const int kAnalogueVideos = 4;
@@ -128,6 +131,14 @@
         "576i",
     };
 
+    static const char * VideoModeAdaptionItems[kVideoModeAdaptions] =
+    {
+        tr("Off"),
+        tr("Frame rate"),
+        tr("HD Only"),
+        tr("Always")
+    };
+
     static const char * TvFormatItems[kTvFormats] =
     {
         "4/3",
@@ -182,6 +193,7 @@
     mNewHdffSetup = gHdffSetup;
 
     Add(new cMenuEditStraItem(tr("Resolution"), &mNewHdffSetup.Resolution, kResolutions, ResolutionItems));
+    Add(new cMenuEditStraItem(tr("Video Mode Adaption"), &mNewHdffSetup.VideoModeAdaption, kVideoModeAdaptions, VideoModeAdaptionItems));
     Add(new cMenuEditStraItem(tr("TV format"), &mNewHdffSetup.TvFormat, kTvFormats, TvFormatItems));
     Add(new cMenuEditStraItem(tr("Video Conversion"), &mNewHdffSetup.VideoConversion, kVideoConversions, VideoConversionItems));
     Add(new cMenuEditStraItem(tr("Analogue Video"), &mNewHdffSetup.AnalogueVideo, kAnalogueVideos, AnalogueVideoItems));
@@ -202,6 +214,7 @@
 void cHdffSetupPage::Store(void)
 {
     SetupStore("Resolution", mNewHdffSetup.Resolution);
+    SetupStore("VideoModeAdaption", mNewHdffSetup.VideoModeAdaption);
     SetupStore("TvFormat", mNewHdffSetup.TvFormat);
     SetupStore("VideoConversion", mNewHdffSetup.VideoConversion);
     SetupStore("AnalogueVideo", mNewHdffSetup.AnalogueVideo);
@@ -237,6 +250,7 @@
         hdmiConfig.TransmitAudio = true;
         hdmiConfig.ForceDviMode = false;
         hdmiConfig.CecEnabled = mNewHdffSetup.CecEnabled;
+        hdmiConfig.VideoModeAdaption = (HDFF::eVideoModeAdaption) mNewHdffSetup.VideoModeAdaption;
         mHdffCmdIf->CmdHdmiConfigure(&hdmiConfig);
 
         mHdffCmdIf->CmdRemoteSetProtocol((HDFF::eRemoteProtocol) mNewHdffSetup.RemoteProtocol);
diff -ruN vdr-1.7.20/PLUGINS/src/dvbhddevice/setup.h vdr-1.7.21/PLUGINS/src/dvbhddevice/setup.h
--- vdr-1.7.20/PLUGINS/src/dvbhddevice/setup.h	2011-04-17 13:20:22.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbhddevice/setup.h	2011-08-27 11:36:02.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: setup.h 1.8 2011/04/17 11:20:22 kls Exp $
+ * $Id: setup.h 1.9 2011/08/27 09:36:02 kls Exp $
  */
 
 #ifndef _HDFF_SETUP_H_
@@ -20,6 +20,7 @@
     HDFF::eHdmiVideoMode GetVideoMode(void);
 
     int Resolution;
+    int VideoModeAdaption;
     int TvFormat;
     int VideoConversion;
     int AnalogueVideo;
diff -ruN vdr-1.7.20/PLUGINS/src/dvbsddevice/HISTORY vdr-1.7.21/PLUGINS/src/dvbsddevice/HISTORY
--- vdr-1.7.20/PLUGINS/src/dvbsddevice/HISTORY	2011-04-17 14:57:29.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbsddevice/HISTORY	2011-08-27 13:36:27.000000000 +0200
@@ -19,3 +19,7 @@
 2011-04-17: Version 0.0.4
 
 - Removed an obsolete local variable in dvbsdffosd.c (thanks to Paul Menzel).
+
+2011-08-27: Version 0.0.5
+
+- Added option --outputonly to use the device only for output (thanks to Udo Richter).
diff -ruN vdr-1.7.20/PLUGINS/src/dvbsddevice/dvbsddevice.c vdr-1.7.21/PLUGINS/src/dvbsddevice/dvbsddevice.c
--- vdr-1.7.20/PLUGINS/src/dvbsddevice/dvbsddevice.c	2011-04-17 14:55:43.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbsddevice/dvbsddevice.c	2011-08-27 13:34:58.000000000 +0200
@@ -3,13 +3,14 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbsddevice.c 1.4 2011/04/17 12:55:43 kls Exp $
+ * $Id: dvbsddevice.c 1.5 2011/08/27 11:34:58 kls Exp $
  */
 
+#include <getopt.h>
 #include <vdr/plugin.h>
 #include "dvbsdffdevice.h"
 
-static const char *VERSION        = "0.0.4";
+static const char *VERSION        = "0.0.5";
 static const char *DESCRIPTION    = "SD Full Featured DVB device";
 
 class cPluginDvbsddevice : public cPlugin {
@@ -20,6 +21,8 @@
   virtual ~cPluginDvbsddevice();
   virtual const char *Version(void) { return VERSION; }
   virtual const char *Description(void) { return DESCRIPTION; }
+  virtual const char *CommandLineHelp(void);
+  virtual bool ProcessArgs(int argc, char *argv[]);
   };
 
 cPluginDvbsddevice::cPluginDvbsddevice(void)
@@ -32,4 +35,27 @@
   delete probe;
 }
 
+const char *cPluginDvbsddevice::CommandLineHelp(void)
+{
+  return "  -o        --outputonly   do not receive, just use as output device\n";
+}
+
+bool cPluginDvbsddevice::ProcessArgs(int argc, char *argv[])
+{
+  static struct option long_options[] = {
+       { "outputonly", no_argument, NULL, 'o' },
+       { NULL,         no_argument, NULL,  0  }
+     };
+
+  int c;
+  while ((c = getopt_long(argc, argv, "", long_options, NULL)) != -1) {
+        switch (c) {
+          case 'o': probe->SetOutputOnly(true);
+                    break;
+          default:  return false;
+          }
+        }
+  return true;
+}
+
 VDRPLUGINCREATOR(cPluginDvbsddevice); // Don't touch this!
diff -ruN vdr-1.7.20/PLUGINS/src/dvbsddevice/dvbsdffdevice.c vdr-1.7.21/PLUGINS/src/dvbsddevice/dvbsdffdevice.c
--- vdr-1.7.20/PLUGINS/src/dvbsddevice/dvbsdffdevice.c	2011-05-22 17:22:14.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbsddevice/dvbsdffdevice.c	2011-08-27 13:33:57.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbsdffdevice.c 2.29 2011/05/22 15:22:14 kls Exp $
+ * $Id: dvbsdffdevice.c 2.30 2011/08/27 11:33:57 kls Exp $
  */
 
 #include "dvbsdffdevice.h"
@@ -23,12 +23,13 @@
 
 int cDvbSdFfDevice::devVideoOffset = -1;
 
-cDvbSdFfDevice::cDvbSdFfDevice(int Adapter, int Frontend)
+cDvbSdFfDevice::cDvbSdFfDevice(int Adapter, int Frontend, bool OutputOnly)
 :cDvbDevice(Adapter, Frontend)
 {
   spuDecoder = NULL;
   digitalAudio = false;
   playMode = pmNone;
+  outputOnly = OutputOnly;
 
   // Devices that are only present on cards with decoders:
 
@@ -357,6 +358,14 @@
   return true;
 }
 
+bool cDvbSdFfDevice::ProvidesSource(int Source) const
+{
+  if (outputOnly)
+     return false;
+  else
+     return cDvbDevice::ProvidesSource(Source);
+}
+
 void cDvbSdFfDevice::TurnOffLiveMode(bool LiveView)
 {
   if (LiveView) {
@@ -761,6 +770,11 @@
 
 // --- cDvbSdFfDeviceProbe ---------------------------------------------------
 
+cDvbSdFfDeviceProbe::cDvbSdFfDeviceProbe(void)
+{
+  outputOnly = false;
+}
+
 bool cDvbSdFfDeviceProbe::Probe(int Adapter, int Frontend)
 {
   static uint32_t SubsystemIds[] = {
@@ -781,7 +795,7 @@
   for (uint32_t *sid = SubsystemIds; *sid; sid++) {
       if (*sid == SubsystemId) {
          dsyslog("creating cDvbSdFfDevice");
-         new cDvbSdFfDevice(Adapter, Frontend);
+         new cDvbSdFfDevice(Adapter, Frontend, outputOnly);
          return true;
          }
       }
diff -ruN vdr-1.7.20/PLUGINS/src/dvbsddevice/dvbsdffdevice.h vdr-1.7.21/PLUGINS/src/dvbsddevice/dvbsdffdevice.h
--- vdr-1.7.20/PLUGINS/src/dvbsddevice/dvbsdffdevice.h	2011-05-21 14:56:49.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/dvbsddevice/dvbsdffdevice.h	2011-08-27 13:32:42.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbsdffdevice.h 2.12 2011/05/21 12:56:49 kls Exp $
+ * $Id: dvbsdffdevice.h 2.13 2011/08/27 11:32:42 kls Exp $
  */
 
 #ifndef __DVBSDFFDEVICE_H
@@ -17,10 +17,11 @@
 class cDvbSdFfDevice : public cDvbDevice {
 private:
   int fd_osd, fd_audio, fd_video, fd_stc;
+  bool outputOnly;
 protected:
   virtual void MakePrimaryDevice(bool On);
 public:
-  cDvbSdFfDevice(int Adapter, int Frontend);
+  cDvbSdFfDevice(int Adapter, int Frontend, bool OutputOnly);
   virtual ~cDvbSdFfDevice();
   virtual bool HasDecoder(void) const;
   virtual bool AvoidRecording(void) const;
@@ -34,6 +35,8 @@
 
 // Channel facilities
 
+public:
+  virtual bool ProvidesSource(int Source) const;
 private:
   void TurnOffLiveMode(bool LiveView);
 protected:
@@ -101,7 +104,11 @@
   };
 
 class cDvbSdFfDeviceProbe : public cDvbDeviceProbe {
+private:
+  bool outputOnly;
 public:
+  cDvbSdFfDeviceProbe(void);
+  void SetOutputOnly(bool On) { outputOnly = On; }
   virtual bool Probe(int Adapter, int Frontend);
   };
  
diff -ruN vdr-1.7.20/PLUGINS/src/skincurses/skincurses.c vdr-1.7.21/PLUGINS/src/skincurses/skincurses.c
--- vdr-1.7.20/PLUGINS/src/skincurses/skincurses.c	2011-05-15 23:41:47.000000000 +0200
+++ vdr-1.7.21/PLUGINS/src/skincurses/skincurses.c	2011-08-21 13:04:38.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: skincurses.c 2.6 2011/05/15 21:41:47 kls Exp $
+ * $Id: skincurses.c 2.7 2011/08/21 11:04:38 kls Exp $
  */
 
 #include <ncurses.h>
@@ -436,7 +436,7 @@
   int y = 2;
   cTextScroller ts;
   char t[32];
-  snprintf(t, sizeof(t), "%s  %s", *DateString(Recording->start), *TimeString(Recording->start));
+  snprintf(t, sizeof(t), "%s  %s", *DateString(Recording->Start()), *TimeString(Recording->Start()));
   ts.Set(osd, 0, y, ScOsdWidth, ScOsdHeight - y - 2, t, &Font, clrYellow, clrBackground);
   y += ts.Height();
   if (Info->GetEvent()->ParentalRating()) {
diff -ruN vdr-1.7.20/channels.c vdr-1.7.21/channels.c
--- vdr-1.7.20/channels.c	2010-11-07 13:24:59.000000000 +0100
+++ vdr-1.7.21/channels.c	2011-08-26 14:44:21.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 2.17 2010/11/07 12:24:59 kls Exp $
+ * $Id: channels.c 2.19 2011/08/26 12:44:21 kls Exp $
  */
 
 #include "channels.h"
@@ -497,8 +497,8 @@
      if (Channel->vpid && Channel->vtype)
         q += snprintf(q, sizeof(vpidbuf) - (q - vpidbuf), "=%d", Channel->vtype);
      *q = 0;
-     const int BufferSize = (MAXAPIDS + MAXDPIDS) * (5 + 1 + MAXLANGCODE2 + 5) + 10; // 5 digits plus delimiting ',' or ';' plus optional '=cod+cod@type', +10: paranoia
-     char apidbuf[BufferSize];
+     const int ABufferSize = (MAXAPIDS + MAXDPIDS) * (5 + 1 + MAXLANGCODE2 + 5) + 10; // 5 digits plus delimiting ',' or ';' plus optional '=cod+cod@type', +10: paranoia
+     char apidbuf[ABufferSize];
      q = apidbuf;
      q += IntArrayToString(q, Channel->apids, 10, Channel->alangs, Channel->atypes);
      if (Channel->dpids[0]) {
@@ -506,11 +506,19 @@
         q += IntArrayToString(q, Channel->dpids, 10, Channel->dlangs, Channel->dtypes);
         }
      *q = 0;
+     const int TBufferSize = MAXSPIDS * (5 + 1 + MAXLANGCODE2) + 10; // 5 digits plus delimiting ',' or ';' plus optional '=cod+cod', +10: paranoia and tpid
+     char tpidbuf[TBufferSize];
+     q = tpidbuf;
+     q += snprintf(q, sizeof(tpidbuf), "%d", Channel->tpid);
+     if (Channel->spids[0]) {
+        *q++ = ';';
+        q += IntArrayToString(q, Channel->spids, 10, Channel->slangs);
+        }
      char caidbuf[MAXCAIDS * 5 + 10]; // 5: 4 digits plus delimiting ',', 10: paranoia
      q = caidbuf;
      q += IntArrayToString(q, Channel->caids, 16);
      *q = 0;
-     buffer = cString::sprintf("%s:%d:%s:%s:%d:%s:%s:%d:%s:%d:%d:%d:%d\n", FullName, Channel->frequency, *Channel->parameters, *cSource::ToString(Channel->source), Channel->srate, vpidbuf, apidbuf, Channel->tpid, caidbuf, Channel->sid, Channel->nid, Channel->tid, Channel->rid);
+     buffer = cString::sprintf("%s:%d:%s:%s:%d:%s:%s:%s:%s:%d:%d:%d:%d\n", FullName, Channel->frequency, *Channel->parameters, *cSource::ToString(Channel->source), Channel->srate, vpidbuf, apidbuf, tpidbuf, caidbuf, Channel->sid, Channel->nid, Channel->tid, Channel->rid);
      }
   return buffer;
 }
@@ -544,14 +552,17 @@
      char *parambuf = NULL;
      char *vpidbuf = NULL;
      char *apidbuf = NULL;
+     char *tpidbuf = NULL;
      char *caidbuf = NULL;
-     int fields = sscanf(s, "%a[^:]:%d :%a[^:]:%a[^:] :%d :%a[^:]:%a[^:]:%d :%a[^:]:%d :%d :%d :%d ", &namebuf, &frequency, &parambuf, &sourcebuf, &srate, &vpidbuf, &apidbuf, &tpid, &caidbuf, &sid, &nid, &tid, &rid);
+     int fields = sscanf(s, "%a[^:]:%d :%a[^:]:%a[^:] :%d :%a[^:]:%a[^:]:%a[^:]:%a[^:]:%d :%d :%d :%d ", &namebuf, &frequency, &parambuf, &sourcebuf, &srate, &vpidbuf, &apidbuf, &tpidbuf, &caidbuf, &sid, &nid, &tid, &rid);
      if (fields >= 9) {
         if (fields == 9) {
            // allow reading of old format
            sid = atoi(caidbuf);
            delete caidbuf;
            caidbuf = NULL;
+           if (sscanf(tpidbuf, "%d", &tpid) != 1)
+              return false;
            caids[0] = tpid;
            caids[1] = 0;
            tpid = 0;
@@ -562,6 +573,7 @@
         atypes[0] = 0;
         dpids[0] = 0;
         dtypes[0] = 0;
+        spids[0] = 0;
         ok = false;
         if (parambuf && sourcebuf && vpidbuf && apidbuf) {
            parameters = parambuf;
@@ -644,7 +656,30 @@
               dpids[NumDpids] = 0;
               dtypes[NumDpids] = 0;
               }
-
+           int NumSpids = 0;
+           if ((p = strchr(tpidbuf, ';')) != NULL) {
+              *p++ = 0;
+              char *q;
+              char *strtok_next;
+              while ((q = strtok_r(p, ",", &strtok_next)) != NULL) {
+                    if (NumSpids < MAXSPIDS) {
+                       char *l = strchr(q, '=');
+                       if (l) {
+                          *l++ = 0;
+                          strn0cpy(slangs[NumSpids], l, MAXLANGCODE2);
+                          }
+                       else
+                          *slangs[NumSpids] = 0;
+                       spids[NumSpids++] = strtol(q, NULL, 10);
+                       }
+                    else
+                       esyslog("ERROR: too many SPIDs!"); // no need to set ok to 'false'
+                    p = NULL;
+                    }
+              spids[NumSpids] = 0;
+              }
+           if (sscanf(tpidbuf, "%d", &tpid) != 1)
+              return false;
            if (caidbuf) {
               char *p = caidbuf;
               char *q;
@@ -681,6 +716,7 @@
         free(sourcebuf);
         free(vpidbuf);
         free(apidbuf);
+        free(tpidbuf);
         free(caidbuf);
         free(namebuf);
         if (!GetChannelID().Valid()) {
diff -ruN vdr-1.7.20/config.c vdr-1.7.21/config.c
--- vdr-1.7.20/config.c	2011-06-13 16:41:01.000000000 +0200
+++ vdr-1.7.21/config.c	2011-08-20 11:12:05.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 2.14 2011/06/13 14:41:01 kls Exp $
+ * $Id: config.c 2.15 2011/08/20 09:12:05 kls Exp $
  */
 
 #include "config.h"
@@ -395,7 +395,7 @@
   CurrentChannel = -1;
   CurrentVolume = MAXVOLUME;
   CurrentDolby = 0;
-  // InitialChannel is initialized by constructor
+  InitialChannel = "";
   InitialVolume = -1;
   ChannelsWrap = 0;
   EmergencyExit = 1;
diff -ruN vdr-1.7.20/config.h vdr-1.7.21/config.h
--- vdr-1.7.20/config.h	2011-06-21 23:43:01.000000000 +0200
+++ vdr-1.7.21/config.h	2011-08-20 10:51:47.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.33 2011/06/21 21:43:01 kls Exp $
+ * $Id: config.h 2.34 2011/08/20 08:51:47 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.20"
-#define VDRVERSNUM   10720  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.21"
+#define VDRVERSNUM   10721  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.20"
-#define APIVERSNUM   10720  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.21"
+#define APIVERSNUM   10721  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-1.7.20/cutter.c vdr-1.7.21/cutter.c
--- vdr-1.7.20/cutter.c	2011-03-06 15:54:33.000000000 +0100
+++ vdr-1.7.21/cutter.c	2011-08-21 13:08:08.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: cutter.c 2.6 2011/03/06 14:54:33 kls Exp $
+ * $Id: cutter.c 2.8 2011/08/21 11:08:08 kls Exp $
  */
 
 #include "cutter.h"
@@ -75,7 +75,7 @@
      if (!fromFile || !toFile)
         return;
      fromFile->SetReadAhead(MEGABYTE(20));
-     int Index = Mark->position;
+     int Index = Mark->Position();
      Mark = fromMarks.Next(Mark);
      off_t FileSize = 0;
      int CurrentFileNumber = 0;
@@ -163,14 +163,14 @@
 
            // Check editing marks:
 
-           if (Mark && Index >= Mark->position) {
+           if (Mark && Index >= Mark->Position()) {
               Mark = fromMarks.Next(Mark);
               toMarks.Add(LastIFrame);
               if (Mark)
                  toMarks.Add(toIndex->Last() + 1);
               toMarks.Save();
               if (Mark) {
-                 Index = Mark->position;
+                 Index = Mark->Position();
                  Mark = fromMarks.Next(Mark);
                  CurrentFileNumber = 0; // triggers SetOffset before reading next frame
                  cutIn = true;
@@ -208,6 +208,12 @@
      error = false;
      ended = false;
      cRecording Recording(FileName);
+
+     cMarks FromMarks;
+     FromMarks.Load(FileName);
+     if (cMark *First = FromMarks.First())
+        Recording.SetStartTime(Recording.Start() + (int(First->Position() / Recording.FramesPerSecond() + 30) / 60) * 60);
+
      const char *evn = Recording.PrefixFileName('%');
      if (evn && RemoveVideoFile(evn) && MakeDirs(evn, true)) {
         // XXX this can be removed once RenameVideoFile() follows symlinks (see videodir.c)
